<template>
  <div>
    <base-dialog :show="!!error" title="An Error Occured!" @close="handleError">
      <p>{{ error }}</p>
    </base-dialog>
    <base-card>
      <form @submit.prevent="submitForm">
        <div class="form-control">
          <label for="email">Your Email</label>
          <input type="email" name="" id="email" v-model.trim="email" />
        </div>
        <div class="form-control">
          <label for="message">Message</label>
          <textarea
            name=""
            id="message"
            rows="5"
            v-model.trim="message"
          ></textarea>
        </div>
        <div class="actions">
          <base-button>Send Message</base-button>
        </div>
        <small class="errors" v-if="!formIsValid"
          >Please enter proper Input.</small
        >
      </form>
      <base-spinner v-if="isLoading"></base-spinner>
    </base-card>
  </div>
</template>

<script>
export default {
  data: function() {
    return {
      email: '',
      message: '',
      formIsValid: true,
      isLoading: false,
      error: null
    };
  },
  methods: {
    submitForm: async function() {
      this.formIsValid = true;
      if (
        this.email === '' ||
        !this.email.includes('@') ||
        this.message === ''
      ) {
        this.formIsValid = false;
        return;
      }
      this.isLoading = true;
      try {
        await this.$store.dispatch('requests/contactCoach', {
          email: this.email,
          message: this.message,
          coachId: this.$route.params.id
        });
        this.$router.replace('/coaches');
      } catch (error) {
        this.error = error;
      }
      this.isLoading = false;
    },
    handleError: function() {
      this.error = null;
    }
  }
};
</script>

<style scoped>
form {
  margin: 1rem;
  border: 1px solid #ccc;
  border-radius: 12px;
  padding: 1rem;
}

.form-control {
  margin: 0.5rem 0;
}

label {
  font-weight: bold;
  margin-bottom: 0.5rem;
  display: block;
}

input,
textarea {
  display: block;
  width: 100%;
  border: 1px solid rgba(0, 0, 0, 0.4);
  font: inherit;
  padding: 0.5rem;
  border-radius: 4px;
  transition: all 0.2s;
}

input:focus,
textarea:focus {
  border-color: #3d008d;
  background-color: #faf6ff;
  outline: none;
}

.errors {
  font-weight: bold;
  color: red;
}

.actions {
  text-align: center;
}
</style>
